Subject: Re: [PATCH net-next v2 00/13] net: lan966x: add support for PCIe FDMA

From: Herve Codina <[email-masked]>
Date: Tue, 28 Apr 2026 18:07:52 +0200

Hi Daniel, all,

On Tue, 28 Apr 2026 15:06:49 +0200
Daniel Machon <[email-masked]> wrote:

> When lan966x operates as a PCIe endpoint, the driver currently uses
> register-based I/O for frame injection and extraction. This approach is
> functional but slow, topping out at around 33 Mbps on an Intel x86 host
> with a lan966x PCIe card.
> 
> This series adds FDMA (Frame DMA) support for the PCIe path. When
> operating as a PCIe endpoint, the internal FDMA engine on lan966x cannot
> directly access host memory, so DMA buffers are allocated as contiguous
> coherent memory and mapped through the PCIe Address Translation Unit
> (ATU). The ATU provides outbound windows that translate internal FDMA
> addresses to PCIe bus addresses, allowing the FDMA engine to read and
> write host memory. Because the ATU requires contiguous address regions,
> page_pool and normal per-page DMA mappings cannot be used. Instead,
> frames are transferred using memcpy between the ATU-mapped buffers and
> the network stack. With this, throughput increases from ~33 Mbps to
> ~620 Mbps for default MTU.
> 

I have applied the whole series and performed some tests.

Issues observed in v1 are no more present.

Tested-by: Herve Codina <[email-masked]>

Best regards,
Hervé